"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var assert = require("assert");
var XAdES = require("../../");
var XMLSerializer = require("xmldom-alpha").XMLSerializer;
context("xml", function () {
    context("DateTime", function () {
        var DATE = new Date();
        context("Get XML", function () {
            it("Default format", function () {
                var dt = new XAdES.xml.XadesDateTime();
                dt.Value = DATE;
                var xml = dt.GetXml();
                var test = new XMLSerializer().serializeToString(xml);
                assert.equal(test, "<xades:XadesDateTime xmlns:xades=\"http://uri.etsi.org/01903/v1.3.2#\">" + DATE.toISOString() + "</xades:XadesDateTime>");
            });
            it("Format HH:mm:ss", function () {
                var dt = new XAdES.xml.XadesDateTime();
                dt.Value = DATE;
                dt.Format = "HH:mm:ss";
                var xml = dt.GetXml();
                var test = new XMLSerializer().serializeToString(xml);
                assert.equal(/\<xades\:XadesDateTime xmlns\:xades\=\"http\:\/\/uri\.etsi\.org\/01903\/v1\.3\.2\#"\>\d+\:\d+\:\d+\<\/xades\:XadesDateTime\>/.test(test), true);
            });
        });
    });
});
