"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var assert = require("assert");
var XAdES = require("../../");
context("xml", function () {
    context("ObjectIdentifier", function () {
        it("Parse", function () {
            var xmlObject = new XAdES.xml.ObjectIdentifier();
            xmlObject.Description = "Description";
            xmlObject.Identifier.Value = "uri:oid";
            xmlObject.Identifier.Qualifier = "OIDAsURI";
            var ref = new XAdES.xml.DocumentationReference();
            ref.Uri = "http://some1.com";
            xmlObject.DocumentationReferences.Add(ref);
            assert.equal(xmlObject.DocumentationReferences.Count, 1);
            var xml = xmlObject.toString();
            assert.equal(xml, "<xades:ObjectIdentifier xmlns:xades=\"http://uri.etsi.org/01903/v1.3.2#\"><xades:Identifier Qualifier=\"OIDAsURI\">uri:oid</xades:Identifier><xades:Description>Description</xades:Description><xades:DocumentationReferences><xades:DocumentationReference>http://some1.com</xades:DocumentationReference></xades:DocumentationReferences></xades:ObjectIdentifier>");
            var xmlObject2 = XAdES.xml.ObjectIdentifier.LoadXml(xml);
            assert.equal(xmlObject2.Description, xmlObject.Description);
            assert.equal(xmlObject2.Identifier.Value, xmlObject.Identifier.Value);
            assert.equal(xmlObject2.Identifier.Qualifier, xmlObject.Identifier.Qualifier);
            assert.equal(xmlObject2.DocumentationReferences.Count, 1);
            assert.equal(xmlObject2.DocumentationReferences.Item(0).Uri, ref.Uri);
        });
    });
});
